image: docker:latest

services:
  - docker:dind

stages:
  - build
  - push

variables:
  DOCKER_IMAGE_NAME: "docker.io/danylomaryskevych/argocd_test"
  DOCKER_IMAGE_TAG: "latest"

before_script:
  - echo "Preparing environment..."
  - docker info

build:
  stage: build
  script:
    - echo "Building Docker image..."
    - docker build -t $DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG .
    - docker save -o image.tar $DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG
  artifacts:
    paths:
      - image.tar

push:
  stage: push
  script:
    - docker load -i image.tar
    - echo "Logging in to Docker registry..."
    - docker login $CI_REGISTRY -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - docker images
    - echo "Pushing Docker image to registry..."
    - docker push $DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG
#  only:
#    - tags